Subject: bio-based DM's "noclone" changes have been dropped from 5.1 [was: Re: linux-next: Boot hangs 3 minutes with device mapper on s390]

From: Mike Snitzer <[email-masked]>
Date: Tue, 5 Mar 2019 17:21:12 -0500

On Tue, Mar 05 2019 at  1:02pm -0500,
Alexander Duyck <[email-masked]> wrote:

> On Mon, Mar 4, 2019 at 8:03 PM Mike Snitzer <[email-masked]> wrote:
> >
> > Hi,
> >
> > Alexander reported this same boot hang in another thread.  I was able to
> > reproduce using an x86_64 .config that Alexander provided.
> >
> > I've pushed this fix out to linux-next:
> > https://git.kernel.org/pub/scm/linux/kernel/git/device-mapper/linux-dm.git/commit/?h=dm-5.1&id=be2c5301817833f692aadb2e5fa209582db01d3b
> >
> > If you could verify this fix works for you I'd appreciate it.
> >
> > Thanks,
> > Mike
> 
> I've verified I am no longer seeing the issue with this patch applied.

Thanks for testing.

But so you and others are aware: based on further internal discussion
with Mikulas, I decided to drop all the bio-based DM "noclone" changes
that were developed for 5.1.

Mikulas had a really good point that the 10-13% performance benefit seen
with 512b IO workloads all but disappears to only a 1% improvement as
soon as the bio's payload is increased to >= 4K.  Meaning the risk
associated with the noclone changes really is _not_ worth the reward.

I've rebased the dm-5.1 branch accordingly and linux-next will pick it
up tonight.

Mike

ps. in case anyone cares, the noclone changes have been preserved in
this dm-noclone-support branch:
https://git.kernel.org/pub/scm/linux/kernel/git/device-mapper/linux-dm.git/log/?h=dm-noclone-support